unit UnidadCliente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, QuickRpt, QRCtrls, dxgridmenus, ZDataset;

type
  TformCliente = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    actImprimirDatosSobre: TAction;
    LImpresionSobre: TQuickRep;
    TitleBand1: TQRBand;
    LNombre: TQRLabel;
    LDireccion: TQRLabel;
    LCP: TQRLabel;
    LPais: TQRLabel;
    Tablacodigo: TdxDBGridMaskColumn;
    Tablanombre: TdxDBGridMaskColumn;
    Tablacif: TdxDBGridMaskColumn;
    Tablafechaalta: TdxDBGridDateColumn;
    Tabladireccion: TdxDBGridMaskColumn;
    Tablatelefono: TdxDBGridMaskColumn;
    Tablapoblacion: TdxDBGridMaskColumn;
    Tablaprovincia: TdxDBGridMaskColumn;
    Tablacp: TdxDBGridMaskColumn;
    Tablapersonacontacto: TdxDBGridMaskColumn;
    Tablaweb: TdxDBGridMaskColumn;
    Tablaemail: TdxDBGridMaskColumn;
    Tablafax: TdxDBGridMaskColumn;
    Tablapais: TdxDBGridMaskColumn;
    Tablatipo: TdxDBGridMaskColumn;
    Tablaobservacion: TdxDBGridMaskColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid(Posicion: Integer);
    procedure actImprimirDatosSobreExecute(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formCliente: TformCliente;
const
  ventana = 'Tercero';
  ventanas = 'Terceros';

implementation

uses UnidadMenuPrincipal, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGCliente, UnidadImprimir;
{$R *.DFM}

var
  tTabla : TZTable; //tabla del mdulo de datos que
                    //se utilizar para hacer la conexin con la ventana
                    //de modificacin/insercin/visualizacin

procedure TformCliente.llenarGrid(Posicion: Integer);
begin
  md.tcCliente.Close;
  md.tcCliente.SQL.Clear;
  md.tcCliente.SQL.Add('SELECT * FROM ' + vtTablaTercero);
  md.tcCliente.Open;
  md.tcCliente.RecNo := Posicion;
end;


procedure TformCliente.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   esNumINI ('Posicin final', ventana, md.tcCliente.RecNo);
   md.tcCliente.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformCliente.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformCliente.ActNuevoExecute(Sender: TObject);
begin
  vtAccion := 'nuevo';
  application.createform(tformGCliente, formGCliente);
  formGCliente.ShowModal;
  LlenarGrid(md.tcCliente.RecNo);
end;

procedure TformCliente.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
  eliminar : boolean;
begin
  if md.tcCliente.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    tTabla.Active := true;
    if tTabla.locate('Codigo', md.tcClienteCodigo.value, []) then
    begin
      if not varisnull(md.tcClienteNombre.Value) then
        nombre := md.tcClienteNombre.Value
      else
        nombre := null;
      eliminar := true;
      with md.TC do
      begin
        //comprobamos integridad referencial: FACTURAS
        Close;
        SQL.Clear;
        SQL.Add('SELECT count(CodigoCliente) NumeroT');
        SQL.Add('FROM ' + vtTablaFactura);
        SQL.Add('WHERE CodigoCliente = :pCodigo');
        ParamByName('pCodigo').DataType := ftString;
        ParamByName('pCodigo').Value := md.tcClienteCodigo.Value;
        Open;
        if FieldByName('NumeroT').value > 0 then
        begin
          eliminar := false;
          messagedlg ('El ' + ventana + ' [' + nombre + '] no se puede ' +
              'eliminar ya que existe en facturas.', mtWarning, [mbok], 0);
        end;

        //comprobamos integridad referencial: COBRO
        Close;
        SQL.Clear;
        SQL.Add('SELECT count(CodigoCliente) NumeroT');
        SQL.Add('FROM ' + vtTablaCobro);
        SQL.Add('WHERE CodigoCliente = :pCodigo');
        ParamByName('pCodigo').DataType := ftString;
        ParamByName('pCodigo').Value := md.tcClienteCodigo.Value;
        Open;
        if FieldByName('NumeroT').value > 0 then
        begin
          eliminar := false;
          messagedlg ('El ' + ventana + ' [' + nombre + '] no se puede ' +
              'eliminar ya que existe en cobros.', mtWarning, [mbok], 0);
        end;



        if eliminar then
        begin
          if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
              nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
          begin
            try
              ttabla.Delete;
              ActRefrescarExecute(nil);
            except
              raise;
            end;
          end;
        end;
      end;
    end;
  end;
end;


procedure TformCliente.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformCliente.ActModificarExecute(Sender: TObject);
begin
  if md.tcCliente.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if not varisnull(md.tcClienteCodigo.value) then
    begin
      vtAccion := 'modificar';
      vtCodigo := md.tcClientecodigo.Value;
      application.createform(TformGCliente, formGCliente);
      formGCliente.ShowModal;
      LlenarGrid(md.tcCliente.RecNo);
    end
    else
      messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.', mtError, [mbok], 0);
  end;
end;

procedure TformCliente.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformCliente.ActRefrescarExecute(Sender: TObject);
begin
  LlenarGrid(md.tcCliente.RecNo);
end;

procedure TformCliente.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformCliente.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformCliente.ActImprimirExecute(Sender: TObject);
begin
  if md.tcCliente.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := vtNumCliente;
    formImprimir.showmodal;
  end;
end;

procedure TformCliente.ActVisualizarExecute(Sender: TObject);
begin
  if md.tcCliente.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'zoom';
    vtCodigo := md.tcClienteCodigo.value;
    application.createform(TformGCliente, formGCliente);
    formGCliente.ShowModal;
  end;
end;

procedure TformCliente.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXLS(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformCliente.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToHTML(dlguardar.filename, true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;


procedure TformCliente.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
  MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
end;

procedure TformCliente.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
    if Length(separador) > 1 then
      MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
    else
    begin
      tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;  
  end;    
end;

procedure TformCliente.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXML(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformCliente.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformCliente.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformCliente.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformCliente.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformCliente.FormCreate(Sender: TObject);
begin
  tTabla := md.tCliente;
  LlenarGrid(leNumINI ('Posicin final', ventana, 0));
end;

procedure TformCliente.actImprimirDatosSobreExecute(Sender: TObject);
var
  cp, ciudad, provincia, pais : string;
begin
  if messagedlg ('Se va a imprimir la direccin del ' + ventana + ': ' + 
      chr(13) + chr(13) + md.tcCliente.fieldbyname('Nombre').Value +
      chr(13) + chr(13) + '   Inserte un sobre en la impresora y pulse Aceptar.',
      mtinformation, mbOKCancel,0) = mrok then
  begin
    if not varisnull(md.tcCliente.fieldbyname('Nombre').value) then
      LNombre.Caption := md.tcCliente.fieldbyname('Nombre').value;
    if not varisnull(md.tcCliente.fieldbyname('Direccion').value) then
      LDireccion.Caption := md.tcCliente.fieldbyname('Direccion').value;
    if not varisnull(md.tcCliente.fieldbyname('CP').value) then
      cp := md.tcCliente.fieldbyname('CP').value
    else
      cp := '';
    if not varisnull (md.tcCliente.fieldbyname('Poblacion').value) then
      ciudad := md.tcCliente.fieldbyname('Poblacion').value
    else
      ciudad := '';
    if not varisnull (md.tcCliente.fieldbyname('Provincia').value) then
      provincia := md.tcCliente.fieldbyname('Provincia').value
    else
      provincia := '';
    if not varisnull (md.tcCliente.fieldbyname('Pais').value) then
      pais := md.tcCliente.fieldbyname('Pais').value
    else
      pais := '';
    LCP.Caption := cp + '  '  + ciudad;
    LPais.Caption := provincia + '   (' + pais + ')';
    limpresionsobre.Print;
  end;
end;

end.
