unit UnidadConfiguracion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, DB, DBTables;

type
  TformConfiguracion = class(TForm)
    tab: TPageControl;
    bCancelar: TButton;
    bAceptar: TButton;
    tabBD: TTabSheet;
    dlAbrir: TOpenDialog;
    GroupBox11: TGroupBox;
    Label3: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    lContra1: TLabel;
    lContra2: TLabel;
    Label2: TLabel;
    txtBDMySQLNombreBD: TEdit;
    txtBDMySQLServidor: TEdit;
    txtBDMySQLUsuario: TEdit;
    txtBDMySQLContrasena: TEdit;
    txtBDMySQLContrasena2: TEdit;
    opBDMySQLPedirUsuario: TCheckBox;
    bProbarConexionMySQL: TButton;
    txtMySQLProtocolo: TComboBox;
    GroupBox12: TGroupBox;
    Label9: TLabel;
    bMySQLCrearTablas: TButton;
    StaticText4: TStaticText;
    txtMySQLFicheroScript: TEdit;
    bSeleccionarScriptMySQL: TButton;
    Memo1: TMemo;
    Label14: TLabel;
    txtMySQLPuerto: TEdit;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtDefectoTipo: TComboBox;
    GroupBox2: TGroupBox;
    opDefectoCambioControl: TCheckBox;
    GroupBox3: TGroupBox;
    opDuplicadoNombreTercero: TCheckBox;
    opDuplicadoNombreArticulo: TCheckBox;
    Label4: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    ComboBox4: TComboBox;
    Label6: TLabel;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    TxtIndeterminado: TEdit;
    TabSheet2: TTabSheet;
    GroupBox5: TGroupBox;
    Label7: TLabel;
    txtEmpresaNombre: TEdit;
    txtEmpresaDireccion: TEdit;
    Label11: TLabel;
    txtEmpresaCIF: TEdit;
    Label12: TLabel;
    GroupBox6: TGroupBox;
    Label13: TLabel;
    ComboBox1: TComboBox;
    Label15: TLabel;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    txtCodigoClienteFacturas: TEdit;
    opCrearFacturaAuto: TCheckBox;
    txtPorcentajeIVA: TEdit;
    Label16: TLabel;
    txtCodigoProveedorFacturas: TEdit;
    Label17: TLabel;
    TabSheet3: TTabSheet;
    GroupBox7: TGroupBox;
    Label18: TLabel;
    bEliminarArticulosFacturas: TButton;
    bEliminarArticulosFacturasProveedores: TButton;
    Label19: TLabel;
    bPonerCeroStock: TButton;
    Label20: TLabel;
    procedure bAceptarClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure bMySQLCrearTablasClick(Sender: TObject);
    procedure bProbarConexionMySQLClick(Sender: TObject);
    procedure opBDMySQLPedirUsuarioClick(Sender: TObject);
    procedure obtenerDatosFinales (odbc : string; sistema : boolean);
    procedure bSeleccionarScriptMySQLClick(Sender: TObject);
    procedure txtPorcentajeIVAKeyPress(Sender: TObject; var Key: Char);
    procedure bEliminarArticulosFacturasClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bEliminarArticulosFacturasProveedoresClick(Sender: TObject);
    procedure bPonerCeroStockClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConfiguracion: TformConfiguracion;

implementation

uses UnidadProcedimientos, UnidadPeticionUsuario, UnidadModuloDatos;

{$R *.dfm}

procedure TformConfiguracion.obtenerDatosFinales (odbc : string; sistema : boolean);
var
  tipo : string;
  bd : string;
  descripcion : string;
  controlador : string;
  servidor : string;
  listener : string;
  usuario : string;
begin
  obtenerDatosODBC (odbc, sistema, bd, tipo, descripcion, controlador, servidor, listener, usuario);
  if bd <> '' then
    txtBDMySQLNombreBD.text := bd
  else
    txtBDMySQLNombreBD.Text := '';
  if servidor <> '' then
    txtBDMySQLServidor.Text := servidor
  else
    txtBDMySQLServidor.Text := '';
  if usuario <> '' then
    txtBDMySQLUsuario.Text := usuario;
end;



procedure TformConfiguracion.bAceptarClick(Sender: TObject);
var
  seguir  : Boolean;
begin
  seguir := true;
  if txtBDMySQLContrasena.Text <> txtBDMySQLContrasena2.Text then
  begin
    seguir := false;
    tabBD.Show;
    MessageDlg('Las contraseas deben coincidir.', mtInformation, [mbok], 0);
    txtBDMySQLContrasena.SetFocus;
  end;

  if seguir then
  begin
    esBoolINI('Base de datos', 'Tipo BD MySQL - Pedir usuario al inicio', opBDMySQLPedirUsuario.Checked);
    esCadINI('Base de datos', 'Tipo BD MySQL - Nombre BD', txtBDMySQLNombreBD.Text);
    esCadINI('Base de datos', 'Tipo BD MySQL - Servidor', txtBDMySQLServidor.Text);
    esCadINI('Base de datos', 'Tipo BD MySQL - Protocolo', txtMySQLProtocolo.Text);
    esCadINI('Base de datos', 'Tipo BD MySQL - Puerto', txtMySQLPuerto.Text);

    esCadINI('Defecto', 'Tipo tercero', txtDefectoTipo.Text);
    esBoolINI('Defecto', 'Cambio control intro', opDefectoCambioControl.Checked);
    esBoolINI('Defecto', 'Permitir duplicado - Nombre tercero', opDuplicadoNombreTercero.Checked);
    esBoolINI('Defecto', 'Permitir duplicado - Nombre articulo', opDuplicadoNombreArticulo.Checked);
    esCadINI('Defecto', 'Valor indeterminado', TxtIndeterminado.Text);
    if txtCodigoClienteFacturas.Text = '' then
      txtCodigoClienteFacturas.Text := '0';
    if txtCodigoProveedorFacturas.Text = '' then
      txtCodigoProveedorFacturas.Text := '0';
    esNumINI('Defecto', 'Cdigo cliente defecto facturas', strtoint(txtCodigoClienteFacturas.Text));
    esNumINI('Defecto', 'Cdigo proveedor defecto facturas', strtoint(txtCodigoProveedorFacturas.Text));
    esBoolINI('Defecto', 'Crear factura automticamente', opCrearFacturaAuto.Checked);

    esCadINI('Empresa', 'Nombre', txtEmpresaNombre.Text);
    esCadINI('Empresa', 'Direccin', txtEmpresaDireccion.Text);
    esCadINI('Empresa', 'CIF', txtEmpresaCIF.Text);

    //esCadINI('Base de datos', 'Tipo BD MySQL - Driver ODBC', txtBDMySQLDriverODBC.Text);
    if not opBDMySQLPedirUsuario.Checked then
    begin
      esCadINI('Base de datos', 'Tipo BD MySQL - Usuario', txtBDMySQLUsuario.Text);
      //esCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', encriptar (txtBDMySQLContrasena.Text, 450));
      esCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', txtBDMySQLContrasena.Text);
    end;

    cargarConfiguracion ();
    Close;
  end;
  MessageDlg('Si ha hecho cambios en el tipo de Base de Datos deber reiniciar ' +
      'la aplicacin.', mtInformation, [mbok], 0);
end;

procedure TformConfiguracion.bCancelarClick(Sender: TObject);
begin
  Close;
end;

procedure TformConfiguracion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformConfiguracion.FormCreate(Sender: TObject);
begin
  txtBDMySQLNombreBD.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Nombre BD', '');
  txtBDMySQLServidor.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Servidor', '');
  txtBDMySQLUsuario.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Usuario', '');
//  txtBDMySQLContrasena.Text := desencriptar (leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', ''), 450);
//  txtBDMySQLContrasena2.Text := desencriptar (leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', ''), 450);
  txtBDMySQLContrasena2.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', '');
  txtBDMySQLContrasena.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', '');
  opBDMySQLPedirUsuario.Checked := leBoolINI('Base de datos', 'Tipo BD MySQL - Pedir usuario al inicio', false);
  txtMySQLProtocolo.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Protocolo', 'mysql4.1');
  txtMySQLPuerto.Text := leCadINI('Base de datos', 'Tipo BD MySQL - Puerto', '3306');
  txtDefectoTipo.ItemIndex := txtDefectoTipo.Items.IndexOf (leCadINI('Defecto', 'Tipo tercero', 'Cliente'));
  opDefectoCambioControl.Checked := leBoolINI('Defecto', 'Cambio control intro', true);
  opDuplicadoNombreTercero.Checked := leBoolINI('Defecto', 'Permitir duplicado - Nombre tercero', true);
  opDuplicadoNombreArticulo.Checked := leBoolINI('Defecto', 'Permitir duplicado - Nombre articulo', true);
  txtIndeterminado.text := leCadINI('Defecto', 'Valor indeterminado', 'Indeterminado');
  txtCodigoClienteFacturas.Text := inttostr(leNumINI('Defecto', 'Cdigo cliente defecto facturas', 1));
  txtCodigoProveedorFacturas.Text := inttostr(leNumINI('Defecto', 'Cdigo proveedor defecto facturas', 1));  
  opCrearFacturaAuto.Checked := leBoolINI('Defecto', 'Crear factura automticamente', true);
  txtEmpresaNombre.Text := leCadINI('Empresa', 'Nombre', '');
  txtEmpresaDireccion.Text := leCadINI('Empresa', 'Direccin', '');
  txtEmpresaCIF.Text := leCadINI('Empresa', 'CIF', '');
end;

procedure TformConfiguracion.bMySQLCrearTablasClick(Sender: TObject);
var
  f : TForm;
begin
  if MessageDlg('ATENCIN: va a ejecutar un fichero de Script, ste puede incluir ' +
      'eliminaciones de tablas ya existentes y SUS DATOS (en caso de que existan).' +
      chr(13) + chr(13) + 'Est seguro que desea continuar?', mtconfirmation, [mbno, mbyes], 0) = mrYes then
  begin
    if FileExists(txtMySQLFicheroScript.Text) then
    begin
      md.bd.Disconnect;
      md.bd.HostName := txtBDMySQLServidor.Text;
      md.bd.Catalog := 'mysql';
      if opBDMySQLPedirUsuario.Checked then
      begin
        F := application.findcomponent('formIncioSesion') as TForm;
        if Assigned(F) then
            f.showmodal
        else
        begin
          application.createform(tformIncioSesion, formIncioSesion);
          formIncioSesion.txtBD.Text := txtBDMySQLNombreBD.Text;
          formIncioSesion.txtTipoBD.Text := 'MySQL';
          //formIncioSesion.txtODBC.Text := '';
          formIncioSesion.showmodal;
        end;
        md.bd.User := vtUsuario;
        md.bd.Password := vtContrasena;
      end
      else
      begin
        md.bd.User := txtBDMySQLUsuario.text;
        md.bd.Password := txtBDMySQLContrasena.text;
      end;
      try
        md.bd.Connect;
      except
        raise;
        exit;
      end;
      md.tScript.LoadFromFile(txtMySQLFicheroScript.Text);
      md.tScript.Execute;
      MessageDlg('El script se ha ejecutado correctamente.', mtInformation, [mbok], 0);
    end
    else
      MessageDlg('El fichero de script SQL seleccionado no existe.', mtWarning, [mbok], 0);
  end;
end;

procedure TformConfiguracion.bProbarConexionMySQLClick(Sender: TObject);
var
  f : TForm;
begin
  md.bd.Disconnect;
  md.bd.Port := StrToInt(txtMySQLPuerto.Text);
  md.bd.HostName := txtBDMySQLServidor.Text;
  md.bd.Catalog := txtBDMySQLNombreBD.Text;
  md.bd.Protocol := txtMySQLProtocolo.Text;
  if opBDMySQLPedirUsuario.Checked then
  begin
    F := application.findcomponent('formIncioSesion') as TForm;
    if Assigned(F) then
        f.showmodal
    else
    begin
      application.createform(tformIncioSesion, formIncioSesion);
      formIncioSesion.txtBD.Text := txtBDMySQLNombreBD.Text;
      formIncioSesion.txtTipoBD.Text := 'MySQL';
      formIncioSesion.showmodal;
    end;
    md.bd.User := vtUsuario;
    md.bd.Password := vtContrasena;
  end
  else
  begin
    md.bd.User := txtBDMySQLUsuario.text;
    md.bd.Password := txtBDMySQLContrasena.text;
  end;
  try
    md.bd.Connect;
    MessageDlg('La conexin se ha realizado con xito.', mtInformation, [mbok], 0);
    md.bd.Disconnect;
  except
    raise;
    exit;
  end;
end;

procedure TformConfiguracion.opBDMySQLPedirUsuarioClick(Sender: TObject);
begin
  if opBDMySQLPedirUsuario.Checked then
  begin
    txtBDMySQLUsuario.Visible := false;
    txtBDMySQLContrasena.Visible := false;
    txtBDMySQLContrasena2.Visible := false;
    lContra1.Visible := false;
    lContra2.Visible := false;
    Label10.Visible := false;
  end
  else
  begin
    txtBDMySQLUsuario.Visible := true;
    txtBDMySQLContrasena.Visible := true;
    txtBDMySQLContrasena2.Visible := true;
    lContra1.Visible := true;
    lContra2.Visible := true;
    Label10.Visible := true;
  end;
end;

procedure TformConfiguracion.bSeleccionarScriptMySQLClick(Sender: TObject);
begin
  dlAbrir.Title := 'Seleccione script SQL de MySQL';
  dlAbrir.InitialDir := ExtractFilePath (Application.ExeName);
  dlAbrir.FileName := 'creacin tablas MySQL - AntiSpam.sql';
  if dlAbrir.Execute then
    txtMySQLFicheroScript.Text := dlAbrir.FileName;
end;

procedure TformConfiguracion.txtPorcentajeIVAKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key :=',';
end;

procedure TformConfiguracion.bEliminarArticulosFacturasClick(
  Sender: TObject);
var
  numReg : integer;
begin
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select count(codigo) NumReg FROM ' + vtTablaFacturaDetalle);
  md.tc.SQL.Add('WHERE codigofactura not in (');
  md.tc.SQL.Add('  select codigo');
  md.tc.SQL.Add('  from ' + vtTablaFactura + ')');
  md.tc.Open;
  numReg := md.tc.fieldbyname('NumReg').asInteger;
  if numReg > 0 then
  begin
    if MessageDlg ('Se van a eliminar ' + IntToStr(numReg) +
        ' detalles de factura sin cdigo asignado desea continuar?',
        mtConfirmation, [mbyes,mbno], 0) = mryes then
    begin
      md.tc.SQL.Clear;
      md.tc.SQL.Add('DELETE FROM ' + vtTablaFacturaDetalle);
      md.tc.SQL.Add('WHERE codigo not in (');
      md.tc.SQL.Add('  select codigo');
      md.tc.SQL.Add('  from ' + vtTablaFactura + ')');
      try
        md.tc.ExecSQL;
        MessageDlg('El proceso ha finalizado correctamente.', mtInformation,
            [mbok], 0);
      except
        raise
      end;
    end;
  end
  else
    MessageDlg('No hay registros para eliminar.', mtinformation,[mbok],0);
end;

procedure TformConfiguracion.FormShow(Sender: TObject);
begin
  tabBD.Show;
end;

procedure TformConfiguracion.bEliminarArticulosFacturasProveedoresClick(Sender: TObject);
var
  numReg : integer;
begin
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select count(codigo) NumReg FROM ' + vtTablaFacturaProveedorDetalle);
  md.tc.SQL.Add('WHERE codigofactura not in (');
  md.tc.SQL.Add('  select codigo');
  md.tc.SQL.Add('  from ' + vtTablaFacturaProveedor + ')');
  md.tc.Open;
  numReg := md.tc.fieldbyname('NumReg').asInteger;
  if numReg > 0 then
  begin
    if MessageDlg ('Se van a eliminar ' + IntToStr(numReg) +
        ' detalles de factura sin cdigo asignado desea continuar?',
        mtConfirmation, [mbyes,mbno], 0) = mryes then
    begin
      md.tc.SQL.Clear;
      md.tc.SQL.Add('DELETE FROM ' + vtTablaFacturaProveedorDetalle);
      md.tc.SQL.Add('WHERE codigo not in (');
      md.tc.SQL.Add('  select codigo');
      md.tc.SQL.Add('  from ' + vtTablaFacturaProveedor + ')');
      try
        md.tc.ExecSQL;
        MessageDlg('El proceso ha finalizado correctamente.', mtInformation,
            [mbok], 0);
      except
        raise
      end;
    end;
  end
  else
    MessageDlg('No hay registros para eliminar.', mtinformation,[mbok],0);
end;

procedure TformConfiguracion.bPonerCeroStockClick(Sender: TObject);
var
  numReg : integer;
begin
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select count(codigo) NumReg FROM ' + vtTablaArticulo);
  md.tc.SQL.Add('where stock <> 0');
  md.tc.Open;
  numReg := md.tc.fieldbyname('NumReg').asInteger;
  if numReg > 0 then
  begin
    if MessageDlg ('Se va a poner a cero el stock de ' + IntToStr(numReg) +
        ' artculos desea continuar?',
        mtConfirmation, [mbyes,mbno], 0) = mryes then
    begin
      md.tc.SQL.Clear;
      md.tc.SQL.Add('UPDATE ' + vtTablaArticulo);
      md.tc.SQL.Add('SET stock = 0');
      md.tc.SQL.Add('where stock <> 0');      
      try
        md.tc.ExecSQL;
        MessageDlg('El proceso ha finalizado correctamente.', mtInformation,
            [mbok], 0);
      except
        raise
      end;
    end;
  end
  else
    MessageDlg('No hay registros para actualizar.', mtinformation,[mbok],0);
end;

end.
