unit UnidadContador;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, dxgridmenus, zdataset;

type
  TformContador = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    Tablatabla: TdxDBGridMaskColumn;
    Tablacontador: TdxDBGridMaskColumn;
    ToolButton5: TToolButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid(Posicion : Integer);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formContador: TformContador;
const
  ventana = 'Contador';
  ventanas = 'Contadores';

implementation

uses UnidadMenuPrincipal, UnidadImprimir, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGContador;
{$R *.DFM}

var
  tTabla : TZTable;


procedure TformContador.llenarGrid(Posicion : Integer);
begin
  md.tcContador.Close;
  md.tcContador.SQL.Clear;
  md.tcContador.SQL.Add('SELECT * FROM ' + vtTablaContador);
  md.tcContador.Open;
  md.tcContador.RecNo := Posicion;
  Tabla.Refresh;
end;

  
procedure TformContador.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   esNumINI ('Posicin final', ventana, md.tcContador.RecNo);
   md.tcContador.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformContador.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformContador.ActNuevoExecute(Sender: TObject);
begin
  vtAccion := 'nuevo';
  application.createform(tformContadorG, formContadorG);
  formContadorG.ShowModal;
  ActRefrescarExecute(nil);
end;

procedure TformContador.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
begin
  if md.tcContador.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    tTabla.Active := true;
    if tTabla.locate('tabla', md.tcContadortabla.value, []) then
    begin
      if not varisnull(md.tcArticuloNombre.Value) then
        nombre := md.tcArticuloNombre.Value
      else
        nombre := null;
      if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
          nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
      begin
        try
          ttabla.Delete;
          ActRefrescarExecute(nil);
        except
          raise;
        end;
      end;
    end;
  end;
end;

procedure TformContador.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformContador.ActModificarExecute(Sender: TObject);
begin
  if md.tcContador.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'modificar';
    vtCodigoTexto := md.tcContadortabla.value;
    application.createform(tformContadorG, formContadorG);
    formContadorG.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TformContador.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformContador.ActRefrescarExecute(Sender: TObject);
begin
  llenarGrid (md.tcContador.RecNo);
end;

procedure TformContador.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformContador.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformContador.ActVisualizarExecute(Sender: TObject);
begin
  if md.tcContador.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'zoom';
    vtCodigoTexto := md.tcContadortabla.asString;
    application.createform(tformContadorG, formContadorG);
    formContadorG.ShowModal;
  end;
end;

procedure TformContador.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
    tabla.SaveToXLS(dlguardar.FileName,true);
end;

procedure TformContador.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
    tabla.SaveToHTML(dlguardar.filename, true);
end;


procedure TformContador.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
end;

procedure TformContador.actEnviarTodosTextoExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
    tabla.SaveToText(dlguardar.filename, true,#9, '|', '|');
end;

procedure TformContador.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
    tabla.SaveToXML(dlguardar.FileName,true);
end;

procedure TformContador.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformContador.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformContador.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformContador.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformContador.FormCreate(Sender: TObject);
begin
  tTabla := md.tContador;
  llenarGrid(leNumINI ('Posicin final', ventana, 0));
end;

end.
