unit UnidadEjecucionConsultas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ComCtrls, ToolWin, ExtCtrls, StdCtrls, dxExEdtr,
  dxCntner, dxTL, dxDBCtrl, dxDBGrid;

type
  TformEjecucionConsultas = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton11: TToolButton;
    ToolButton7: TToolButton;
    ActionList1: TActionList;
    actGuardarConsulta: TAction;
    actEjecutarConsulta: TAction;
    ActCerrar: TAction;
    txtSQL: TMemo;
    Splitter1: TSplitter;
    tabla: TdxDBGrid;
    actMostrarSQL: TAction;
    ToolButton2: TToolButton;
    actExportarExcel: TAction;
    dlGuardar: TSaveDialog;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    actExportarHTML: TAction;
    ToolButton8: TToolButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure actEjecutarConsultaExecute(Sender: TObject);
    procedure actMostrarSQLExecute(Sender: TObject);
    procedure actGuardarConsultaExecute(Sender: TObject);
    procedure actExportarExcelExecute(Sender: TObject);
    procedure actExportarHTMLExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formEjecucionConsultas: TformEjecucionConsultas;

implementation

uses UnidadModuloDatos, UnidadSQL;

{$R *.dfm}

procedure TformEjecucionConsultas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.cursor := crdefault;
  md.tcEjecutarSQL.Close;
  Action := caFree;
end;

procedure TformEjecucionConsultas.FormShow(Sender: TObject);
begin
  screen.cursor := crdefault;
end;

procedure TformEjecucionConsultas.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformEjecucionConsultas.actEjecutarConsultaExecute(
  Sender: TObject);
begin
  md.tcEjecutarSQL.Close;
  md.tcEjecutarSQL.SQL.Clear;
  md.tcEjecutarSQL.SQL.Text := txtSQL.Text;
  md.tcEjecutarSQL.Open;
end;

procedure TformEjecucionConsultas.actMostrarSQLExecute(Sender: TObject);
begin
  md.tSQL.Open;
  application.createform(TFormSQL, FormSQL);
  FormSQL.showmodal;
end;

procedure TformEjecucionConsultas.actGuardarConsultaExecute(
  Sender: TObject);
begin
  md.tSQL.Open;
  md.tSQL.Insert;
  md.tSQLsql.Value := txtSQL.Text;
  application.createform(TFormSQL, FormSQL);
  FormSQL.showmodal;
end;

procedure TformEjecucionConsultas.actExportarExcelExecute(Sender: TObject);
begin
  if dlGuardar.Execute then
    tabla.SaveToXLS(dlGuardar.FileName, false);
end;

procedure TformEjecucionConsultas.actExportarHTMLExecute(Sender: TObject);
begin
  if dlGuardar.Execute then
    tabla.SaveToHTML(dlGuardar.FileName, false);
end;

end.
