unit UnidadFacturaProveedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, dxgridmenus,
  ZAbstractRODataset, ZAbstractDataset, ZDataset;

type
  TformFacturaProveedor = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    Tablacodigo: TdxDBGridMaskColumn;
    Tablanumero: TdxDBGridMaskColumn;
    Tablaimportetotal: TdxDBGridMaskColumn;
    Tablabaseimponible: TdxDBGridMaskColumn;
    Tablaporcentajeiva: TdxDBGridMaskColumn;
    Tablaimporteiva: TdxDBGridMaskColumn;
    Tablaporcentajedescuento: TdxDBGridMaskColumn;
    Tablaimportedescuento: TdxDBGridMaskColumn;
    Tablacodigoproveedor: TdxDBGridMaskColumn;
    Tablafecha: TdxDBGridDateColumn;
    Tablacobrado: TdxDBGridMaskColumn;
    Tablaobservacion: TdxDBGridMaskColumn;
    Tablaimportecobrado: TdxDBGridMaskColumn;
    TablaProveedor: TdxDBGridMaskColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid(Posicion: Integer);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formFacturaProveedor: TformFacturaProveedor;
const
  ventana = 'Factura proveedor';
  ventanas = 'Facturas proveedor';

implementation

uses UnidadMenuPrincipal, UnidadImprimir, UnidadModuloDatos,
  UnidadProcedimientos, UnidadGFacturaProveedor;
{$R *.DFM}

var
  tTabla : TZTable;

procedure TformFacturaProveedor.llenarGrid(Posicion: Integer);
begin
  md.tcFacturaProveedor.Close;
  md.tcFacturaProveedor.SQL.Clear;
  md.tcFacturaProveedor.SQL.Add('select f.*, c.nombre Proveedor');
  md.tcFacturaProveedor.SQL.Add('from ' + vtTablaFacturaProveedor + ' f, ' + vtTablaTercero + ' c');
  md.tcFacturaProveedor.SQL.Add('where f.codigoProveedor = c.codigo');
  md.tcFacturaProveedor.Open;
  md.tcFacturaProveedor.RecNo := Posicion;
end;


procedure TformFacturaProveedor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  esNumINI ('Posicin final', ventana, md.tcFacturaProveedor.RecNo);
  try
    md.tcFacturaProveedor.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformFacturaProveedor.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformFacturaProveedor.ActNuevoExecute(Sender: TObject);
begin
    vtAccion := 'nuevo';
    application.createform(TformGFacturaProveedor, formGFacturaProveedor);
    formGFacturaProveedor.ShowModal;
    ActRefrescarExecute(nil);
end;

procedure TformFacturaProveedor.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
begin
  if md.tcFacturaProveedor.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
      tTabla.Active := true;
      if tTabla.locate('Codigo', md.tcFacturaProveedorCodigo.value, []) then
      begin
        if not varisnull(md.tcFacturaProveedorCodigo.Value) then
          nombre := md.tcFacturaProveedornumero.Value
        else
          nombre := null;
        if messagedlg ('Est seguro que desea eliminar la ' + ventana + ': ' +
            nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
        begin
          try
            md.tcFacturaProveedor.Close;
            md.tcFacturaProveedor.sql.clear;
            md.tcFacturaProveedor.SQL.add('DELETE FROM ' + vtTablaFacturaProveedorDetalle +
                ' WHERE CodigoFactura = :pCodigo');
            md.tcFacturaProveedor.ParamByName('pCodigo').DataType := ftString;
            md.tcFacturaProveedor.ParamByName('pCodigo').Value := md.tcFacturaProveedorcodigo.value;
            md.tcFacturaProveedor.ExecSQL;
            ttabla.Delete;
            ActRefrescarExecute(nil);
          except
            raise;
          end;
        end;
      end;
    end;
end;

procedure TformFacturaProveedor.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformFacturaProveedor.ActModificarExecute(Sender: TObject);
begin
  if md.tcFacturaProveedor.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if not varisnull(md.tcFacturaProveedorCodigo.value) then
    begin
      vtAccion := 'modificar';
      ttabla.Active := true;
      ttabla.locate ('Codigo', md.tcFacturaProveedorCodigo.Value, []);
      ttabla.edit;
      application.createform(TformGFacturaProveedor, formGFacturaProveedor);
      formGFacturaProveedor.ShowModal;
      ActRefrescarExecute(nil);
    end
    else
      messagedlg ('Atencin, la ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.', mtError, [mbok], 0);
  end;
end;

procedure TformFacturaProveedor.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformFacturaProveedor.ActRefrescarExecute(Sender: TObject);
begin
  llenarGrid (md.tcFacturaProveedor.RecNo);
end;

procedure TformFacturaProveedor.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformFacturaProveedor.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformFacturaProveedor.ActImprimirExecute(Sender: TObject);
begin
  if md.tcFacturaProveedor.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := vtNumFactura;
    formImprimir.showmodal;
  end;
end;

procedure TformFacturaProveedor.ActVisualizarExecute(Sender: TObject);
begin
  if md.tcFacturaProveedor.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'zoom';
    vtCodigo := md.tFacturaCodigo.value;
    application.createform(TformGFacturaProveedor, formGFacturaProveedor);
    formGFacturaProveedor.ShowModal;
  end;
end;

procedure TformFacturaProveedor.actEnviarExcelExecute(Sender: TObject);
begin
  if md.tFactura.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
    dlGuardar.DefaultExt := 'xls';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToXLS(dlguardar.FileName,true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformFacturaProveedor.actEnviarHTMLExecute(Sender: TObject);
begin
  if md.tFactura.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
    dlGuardar.DefaultExt := 'html';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToHTML(dlguardar.filename, true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;


procedure TformFacturaProveedor.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  if md.tFactura.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    tabla.CopyAllToClipboard;
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformFacturaProveedor.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  if md.tFactura.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
    dlguardar.FileName := ventanas;
    dlGuardar.DefaultExt := 'txt';
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
      if Length(separador) > 1 then
        MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
      else
      begin
        tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
        MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
      end;
    end;
  end;
end;

procedure TformFacturaProveedor.actEnviarTodosXMLExecute(Sender: TObject);
begin
  if md.tFactura.RecordCount <= 0 then
    MessageDlg ('No hay datos para exportar.', mtWarning, [mbok], 0)
  else
  begin
    dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
    dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
    dlGuardar.DefaultExt := 'xml';
    dlguardar.FileName := ventanas;
    if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
      createdir (extractfilepath(application.ExeName) + 'Exportados');
    dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
    if dlGuardar.execute then
    begin
      tabla.SaveToXML(dlguardar.FileName,true);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformFacturaProveedor.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformFacturaProveedor.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformFacturaProveedor.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformFacturaProveedor.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformFacturaProveedor.FormCreate(Sender: TObject);
begin
  tTabla := md.tFacturaProveedor;
  LlenarGrid(leNumINI ('Posicin final', ventana, 0));
end;

end.
