unit UnidadFamilia;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, QuickRpt, QRCtrls, dxgridmenus, ZDataset;

type
  TformFamilia = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    actImprimirDatosSobre: TAction;
    LImpresionSobre: TQuickRep;
    TitleBand1: TQRBand;
    LNombre: TQRLabel;
    LDireccion: TQRLabel;
    LCP: TQRLabel;
    LPais: TQRLabel;
    Tablacodigo: TdxDBGridColumn;
    Tablanombre: TdxDBGridMaskColumn;
    Tablaobservacion: TdxDBGridMaskColumn;
    Tablacodigoman: TdxDBGridMaskColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid(Posicion: Integer);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formFamilia: TformFamilia;
const
  ventana = 'Familia';
  ventanas = 'Familias';

implementation

uses UnidadMenuPrincipal, UnidadModuloDatos,
 UnidadProcedimientos, UnidadGFamilia, UnidadImprimir;
{$R *.DFM}

var
  tTabla : TZTable; //tabla del mdulo de datos que
                    //se utilizar para hacer la conexin con la ventana
                    //de modificacin/insercin/visualizacin

procedure TformFamilia.llenarGrid(Posicion: Integer);
begin
  md.tcFamilia.Close;
  md.tcFamilia.SQL.Clear;
  md.tcFamilia.SQL.Add('SELECT * FROM ' + vtTablaFamilia);
  md.tcFamilia.Open;
  md.tcFamilia.RecNo := Posicion;
end;


procedure TformFamilia.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   esNumINI ('Posicin final', ventana, md.tcFamilia.RecNo);
   md.tcFamilia.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformFamilia.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformFamilia.ActNuevoExecute(Sender: TObject);
begin
  vtAccion := 'nuevo';
  application.createform(tformGFamilia, formGFamilia);
  formGFamilia.ShowModal;
  LlenarGrid(md.tcFamilia.RecNo);
end;

procedure TformFamilia.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
  eliminar : boolean;
begin
  if md.tcFamilia.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    tTabla.Active := true;
    if tTabla.locate('Codigo', md.tcFamiliaCodigo.value, []) then
    begin
      if not varisnull(md.tcFamiliaNombre.Value) then
        nombre := md.tcFamiliaNombre.Value
      else
        nombre := null;
      eliminar := true;
      with md.TC do
      begin
        //comprobamos integridad referencial: Artculos
        Close;
        SQL.Clear;
        SQL.Add('SELECT count(CodigoFamilia) NumeroT');
        SQL.Add('FROM ' + vtTablaArticulo);
        SQL.Add('WHERE CodigoFamilia = :pCodigo');
        ParamByName('pCodigo').DataType := ftString;
        ParamByName('pCodigo').Value := md.tcFamiliacodigo.Value;
        Open;
        if FieldByName('NumeroT').value > 0 then
        begin
          eliminar := false;
          messagedlg ('El ' + ventana + ' [' + nombre + '] no se puede ' +
              'eliminar ya que existe en artculos.', mtWarning, [mbok], 0);
        end;

        if eliminar then
        begin
          if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
              nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
          begin
            try
              ttabla.Delete;
              ActRefrescarExecute(nil);
            except
              raise;
            end;
          end;
        end;
      end;
    end;
  end;
end;


procedure TformFamilia.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformFamilia.ActModificarExecute(Sender: TObject);
begin
  if md.tcFamilia.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if not varisnull(md.tcFamiliaCodigo.value) then
    begin
      vtAccion := 'modificar';
      vtCodigo := md.tcFamiliacodigo.Value;
      application.createform(TformGFamilia, formGFamilia);
      formGFamilia.ShowModal;
      LlenarGrid(md.tcFamilia.RecNo);
    end
    else
      messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.', mtError, [mbok], 0);
  end;
end;

procedure TformFamilia.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformFamilia.ActRefrescarExecute(Sender: TObject);
begin
  LlenarGrid(md.tcFamilia.RecNo);
end;

procedure TformFamilia.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformFamilia.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformFamilia.ActImprimirExecute(Sender: TObject);
begin
  if md.tcFamilia.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := vtNumFamilia;
    formImprimir.showmodal;
  end;
end;

procedure TformFamilia.ActVisualizarExecute(Sender: TObject);
begin
  if md.tcFamilia.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'zoom';
    vtCodigo := md.tcFamiliaCodigo.value;
    application.createform(TformGFamilia, formGFamilia);
    formGFamilia.ShowModal;
  end;
end;

procedure TformFamilia.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXLS(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformFamilia.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToHTML(dlguardar.filename, true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;


procedure TformFamilia.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
  MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
end;

procedure TformFamilia.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
    if Length(separador) > 1 then
      MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
    else
    begin
      tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;  
  end;    
end;

procedure TformFamilia.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXML(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformFamilia.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformFamilia.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformFamilia.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformFamilia.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformFamilia.FormCreate(Sender: TObject);
begin
  tTabla := md.tFamilia;
  LlenarGrid(leNumINI ('Posicin final', ventana, 0));
end;

end.
