unit UnidadGFacturaLinea;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, variants,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGFacturaLinea = class(TForm)
    Panel1: TPanel;
    txtCodigoArticulo: TDBEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    BSeleccionarProducto: TSpeedButton;
    Label2: TLabel;
    txtConcepto: TDBEdit;
    Label3: TLabel;
    txtCantidad: TDBEdit;
    Label4: TLabel;
    txtImporte: TDBEdit;
    Label5: TLabel;
    txtPrecio: TDBEdit;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    txtCodigoBarras: TEdit;
    lModelo: TLabel;
    lMarca: TLabel;
    lColor: TLabel;
    lTalla: TLabel;
    lStock: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lFamilia: TLabel;
    lRango: TLabel;
    Label17: TLabel;
    txtPorcentajeDto: TDBEdit;
    Label10: TLabel;
    txtArticulo: TLabel;
    lAvisoStock: TStaticText;
    txtPrecioConIVA: TdxCurrencyEdit;
    Label11: TLabel;
    txtImporteConIVA: TdxCurrencyEdit;
    Label12: TLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure txtCodigoArticuloKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarProductoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtCodigoArticuloEnter(Sender: TObject);
    procedure txtPesoNetoEnter(Sender: TObject);
    procedure txtConceptoEnter(Sender: TObject);
    procedure txtCaldoEnter(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtPesoNetoExit(Sender: TObject);
    procedure txtConceptoExit(Sender: TObject);
    procedure txtCaldoExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtPlazoEnter(Sender: TObject);
    procedure txtPlazoExit(Sender: TObject);
    procedure txtFechaDisposicionEnter(Sender: TObject);
    procedure txtFechaDisposicionExit(Sender: TObject);
    procedure txtOperacionEnter(Sender: TObject);
    procedure txtOperacionExit(Sender: TObject);
    procedure txtPesoNetoKeyPress(Sender: TObject; var Key: Char);
    procedure txtTaraEnvaseExit(Sender: TObject);
    procedure txtTaraEnvaseEnter(Sender: TObject);
    procedure txtTipoEnvaseExit(Sender: TObject);
    procedure txtTipoEnvaseEnter(Sender: TObject);
    procedure txtNumeroEnvasesEnter(Sender: TObject);
    procedure txtNumeroEnvasesExit(Sender: TObject);
    procedure txtProductoEnter(Sender: TObject);
    procedure txtVariedadEnter(Sender: TObject);
    procedure txtCalibreEnter(Sender: TObject);
    procedure txtCategoriaEnter(Sender: TObject);
    procedure txtProductoExit(Sender: TObject);
    procedure txtVariedadExit(Sender: TObject);
    procedure txtCalibreExit(Sender: TObject);
    procedure txtCategoriaExit(Sender: TObject);
    procedure txtCodigoArticuloExit(Sender: TObject);
    procedure txtCantidadKeyPress(Sender: TObject; var Key: Char);
    function calcularImporte () : double;
    procedure txtCodigoBarrasChange(Sender: TObject);
    procedure obtenerDatosArticulo (codigo : integer; codigobarras : string);
    procedure txtCantidadExit(Sender: TObject);
    procedure txtPrecioExit(Sender: TObject);
    procedure txtCodigoBarrasEnter(Sender: TObject);
    procedure txtPrecioEnter(Sender: TObject);
    procedure txtCantidadEnter(Sender: TObject);
    procedure txtImporteEnter(Sender: TObject);
    procedure txtImporteExit(Sender: TObject);
    procedure txtCodigoBarrasExit(Sender: TObject);
    procedure txtPrecioConIVAExit(Sender: TObject);
    procedure txtImporteConIVAExit(Sender: TObject);
    procedure txtImporteConIVAEnter(Sender: TObject);
    procedure txtPrecioConIVAEnter(Sender: TObject);
    function calcularImporteIVA () : double;
  private
    { Private declarations }
    codigoArticuloAnterior : integer;
    cantidadActual : Double;
  public
    { Public declarations }
  end;

var
  formGFacturaLinea: TformGFacturaLinea;
const
  ventana = 'Lnea de Factura';
  ventanas = 'Lneas de Factura';

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal, UnidadSeleccion,
  UnidadGFactura, UnidadProcedimientos;

{$R *.DFM}


procedure TformGFacturaLinea.obtenerDatosArticulo (codigo : integer; codigobarras : string);
begin
  md.TC2.Close;
  md.TC2.SQL.Clear;
  md.TC2.SQL.Add('Select a.*,t.nombre talla,c.nombre color,m.nombre marca,mo.nombre modelo,g.nombre genero,r.nombre rango, f.nombre familia');
  md.TC2.SQL.Add ('from ' + vtTablaArticulo +  ' a,' + vtTablaTalla +
      ' t,' + vtTablaColor + ' c,' + vtTablaMarca + ' m,' + vtTablaModelo + ' mo,' +
      vtTablaGenero + ' g,' + vtTablaRango + ' r,' + vtTablaFamilia + ' f');
  md.TC2.SQL.Add ('where t.codigo=a.codigotalla and c.codigo=a.codigocolor and m.codigo=a.codigomarca');
  md.TC2.SQL.Add ('and mo.codigo=a.codigomodelo and g.codigo=a.codigogenero and r.codigo=a.codigorango');
  md.TC2.SQL.Add('and f.codigo=a.codigofamilia');
  if codigobarras <> '' then
  begin
    md.TC2.SQL.Add('and a.codigobarras = :pCodigo');
    md.TC2.ParamByName('pCodigo').Value := codigobarras;
  end
  else
  begin
    md.TC2.SQL.Add('and a.codigo= :pCodigo');
    md.TC2.ParamByName('pCodigo').Value := codigo;
  end;

  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
  begin
    txtArticulo.Caption := md.TC2.fieldbyname('nombre').asString;
    if (md.tFacturaDetalleprecio.AsFloat = 0) or (codigoArticuloAnterior <> codigo) then
      md.tFacturaDetalleprecio.value := md.TC2.fieldbyname('precioventa').asFloat;
    if (md.tFacturaDetalleconcepto.AsString = '') or (codigoArticuloAnterior <> codigo) then
      md.tFacturaDetalleconcepto.value := md.TC2.fieldbyname('nombre').asString;
    if (md.tFacturaDetallecantidad.AsString = '') or (md.tFacturaDetallecantidad.AsString = '0') then
      md.tFacturaDetallecantidad.value := 1;
    md.tFacturaDetalleimporte.value := md.tc2.fieldbyname('precioventa').AsFloat;
    md.tFacturaDetalleporcentajedto.value := md.tc2.fieldbyname('porcentajedto').AsFloat;
    if codigobarras <> '' then
      md.tFacturaDetallecodigoarticulo.value := md.tc2.fieldbyname('codigo').AsInteger;
    //txtCodigoBarras.Text := md.tc2.fieldbyname('codigobarras').AsString;
    ltalla.Caption := md.tc2.fieldbyname('talla').Value;
    lcolor.Caption := md.tc2.fieldbyname('color').Value;
    lmarca.Caption := md.tc2.fieldbyname('marca').Value;
    lmodelo.Caption := md.tc2.fieldbyname('modelo').Value;
    lrango.Caption := md.tc2.fieldbyname('rango').Value;
    lfamilia.Caption := md.tc2.fieldbyname('familia').Value;
    lstock.Caption := md.tc2.fieldbyname('stock').AsString;
    md.tFacturaDetalleimporte.Value := calcularImporte;
    if md.tc2.FieldByName('stock').AsFloat < md.tc2.FieldByName('stockminimo').AsFloat then
    begin
      lAvisoStock.Caption := 'Atencin: el stock actual del artculo es inferior a ' +
          md.tc2.fieldbyname ('stockminimo').AsString;
      lAvisoStock.Visible := true
    end
    else
      lAvisoStock.Visible := false;
  end
  else
  begin
    txtArticulo.Caption := '';
    md.tFacturaDetalleprecio.value := 0;
    md.tFacturaDetalleconcepto.value := '';
    if (md.tFacturaDetallecantidad.AsString = '') or (md.tFacturaDetallecantidad.AsString = '0') then
      md.tFacturaDetallecantidad.value := 1;
    if (md.tFacturaDetalleimporte.AsString = '') or (md.tFacturaDetalleimporte.AsString = '0') then
      md.tFacturaDetalleimporte.value := 0;
    ltalla.Caption := '';
    lcolor.Caption := '';
    lmarca.Caption := '';
    lmodelo.Caption := '';
    lrango.Caption := '';
    lfamilia.Caption := '';
    lstock.Caption := '';
    lAvisoStock.Visible := false;
  end;
  txtArticulo.Hint := txtArticulo.Caption;  
end;


function TformGFacturaLinea.calcularImporte () : double;
begin
  result := md.tFacturaDetalleprecio.AsFloat * md.tFacturaDetallecantidad.AsFloat *
      (1 - md.tFacturaDetalleporcentajedto.AsFloat / 100);
end;

function TformGFacturaLinea.calcularImporteIVA () : double;
begin
  result := round ((md.tFacturaDetalleprecio.AsFloat * md.tFacturaDetallecantidad.AsFloat *
      (1 - md.tFacturaDetalleporcentajedto.AsFloat / 100)) * 1.16 * 100) / 100;
end;

procedure TformGFacturaLinea.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformGFacturaLinea.BAceptarClick(Sender: TObject);
begin
  if (txtCodigoArticulo.Text = '') or (txtArticulo.Caption = '') then
  begin
    messagedlg ('Debe introducir un cdigo de artculo existente.', mtinformation, [mbok], 0);
    txtCodigoArticulo.setfocus;
    exit;
  end;

  try
    md.tFacturaDetalle.Post; //validar
    actualizarStock (false, md.tFacturaDetallecantidad.AsFloat - cantidadActual, md.tFacturaDetallecodigoarticulo.AsInteger);
  except
    txtCodigoArticulo.setfocus;
    raise;
  end;
  close;
end;

procedure TformGFacturaLinea.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    if (md.tFacturaDetalle.State = dsedit) or
        (md.tFacturaDetalle.State = dsinsert) then
      md.tFacturaDetalle.cancel;
  except
    //silenciosa
  end;
  action := cafree;
end;

procedure TformGFacturaLinea.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGFacturaLinea.FormShow(Sender: TObject);
begin
  cantidadActual := 0;
  
  md.tFacturaDetalle.Open;

  if tag = 1 then //Nuevo
  begin
    caption := 'Nueva ' + ventana + '...';
    md.tFacturaDetalle.Open;
    md.tFacturaDetalle.Insert;
    md.tFacturaDetalle.FieldByName('CodigoFactura').Value := md.tFacturaCodigo.Value;
  end;

  if tag = 2 then //Modificar
  begin
    BSeleccionarProducto.Enabled := true;
    md.tFacturaDetalle.edit;
    txtCodigoArticulo.SetFocus;
    caption := 'Modificacin de ' + ventana + '...';
    obtenerDatosArticulo(md.tFacturaDetallecodigoarticulo.Value, '');
    cantidadActual := md.tFacturaDetallecantidad.AsFloat;    
  end;

  if tag = 3 then //zoom
  begin
    BAceptar.Visible := false;
    BSeleccionarProducto.Enabled := false;
    obtenerDatosArticulo(md.tFacturaDetallecodigoarticulo.Value, '');
    caption := 'Visualizar de ' + ventana + '...';
  end;
end;

procedure TformGFacturaLinea.txtCodigoArticuloKeyPress(Sender: TObject;
  var Key: Char);
begin
  if formGFactura.Tag <> 3 then //zoom
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarProductoClick(nil);
    end;
  end;
end;

procedure TformGFacturaLinea.BSeleccionarProductoClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumArticulo;
  formseleccion.ShowModal;
  if vtClaveElegida <> -1 then
  begin
    codigoArticuloAnterior := vtNumArticulo;
    md.tFacturaDetallecodigoarticulo.Value := vtClaveElegida;
    obtenerDatosArticulo(vtClaveElegida, '');
  end;
end;


procedure TformGFacturaLinea.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //teclas de cursor para cambiar el foco
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (activecontrol is tdbmemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGFacturaLinea.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCodigoArticuloEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
  codigoArticuloAnterior := md.tfacturadetallecodigoarticulo.asInteger;
end;

procedure TformGFacturaLinea.txtPesoNetoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtConceptoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCaldoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtPesoNetoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtConceptoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtCaldoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtPlazoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtPlazoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtFechaDisposicionEnter(
  Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtFechaDisposicionExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtOperacionEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtOperacionExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtPesoNetoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFacturaLinea.txtTaraEnvaseExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;  
end;

procedure TformGFacturaLinea.txtTaraEnvaseEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtTipoEnvaseExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtTipoEnvaseEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtNumeroEnvasesEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtNumeroEnvasesExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtProductoEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtVariedadEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCalibreEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCategoriaEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtProductoExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtVariedadExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtCalibreExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtCategoriaExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtCodigoArticuloExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  if not (md.tFacturaDetallecodigoarticulo.Value = null) and
      not (md.tFacturaDetallecodigoarticulo.Value = 0) then
    obtenerDatosArticulo (md.tFacturaDetallecodigoarticulo.Value, '')
  else     
    txtArticulo.Caption := '';
  md.tFacturaDetalleimporte.Value := calcularImporte;
end;

procedure TformGFacturaLinea.txtCantidadKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFacturaLinea.txtCodigoBarrasChange(Sender: TObject);
begin
  if (Length (txtCodigoBarras.Text) = 13) or (Length (txtCodigoBarras.Text) = 8) then
    obtenerDatosArticulo (0, txtCodigoBarras.Text);
end;

procedure TformGFacturaLinea.txtCantidadExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  md.tFacturaDetalleimporte.Value := calcularImporte;
  txtImporteConIVA.Value := calcularImporteIVA;
end;

procedure TformGFacturaLinea.txtPrecioExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
{  md.tFacturaDetalleimporte.Value := calcularImporte;
  txtImporteConIVA.Value := calcularImporteIVA;}
end;

procedure TformGFacturaLinea.txtCodigoBarrasEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtPrecioEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtCantidadEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtImporteEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtImporteExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtCodigoBarrasExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLinea.txtPrecioConIVAExit(Sender: TObject);
begin
  TdxCurrencyEdit(sender).Color := clWindow;
  if (txtPrecioConIVA.Text <> '') and (txtPrecioConIVA.Text <> '0') then
  begin
    md.tFacturaDetalleprecio.Value := StrToFloat (txtPrecioConIVA.Text) / 1.16;
    md.tFacturaDetalleimporte.Value := calcularImporte;
    txtImporteConIVA.Value := calcularImporteIVA;
  end;

end;

procedure TformGFacturaLinea.txtImporteConIVAExit(Sender: TObject);
begin
  TdxCurrencyEdit(sender).Color := clWindow;
{  if (txtImporteConIVA.Text <> '') and (txtImporteConIVA.Text <> '0') then
    md.tFacturaDetalleimporte.Value := StrToFloat (txtImporteConIVA.Text) -
        ((16 * StrToFloat (txtImporteConIVA.Text)) / 100);}
end;

procedure TformGFacturaLinea.txtImporteConIVAEnter(Sender: TObject);
begin
  TdxCurrencyEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLinea.txtPrecioConIVAEnter(Sender: TObject);
begin
  TdxCurrencyEdit(sender).Color := clMoneyGreen;
end;

end.
