unit UnidadGFacturaLineaProveedor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db, ComCtrls, variants,
  dxCntner, dxEditor, dxExEdtr, dxEdLib, dxDBELib;

type
  TformGFacturaLineaProveedor = class(TForm)
    Panel1: TPanel;
    txtCodigoArticulo: TDBEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    BSeleccionarProducto: TSpeedButton;
    Label2: TLabel;
    txtConcepto: TDBEdit;
    Label3: TLabel;
    txtCantidad: TDBEdit;
    Label4: TLabel;
    txtImporte: TDBEdit;
    Label5: TLabel;
    txtPrecio: TDBEdit;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lModelo: TLabel;
    lMarca: TLabel;
    lColor: TLabel;
    lTalla: TLabel;
    lStock: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    lFamilia: TLabel;
    lRango: TLabel;
    Label17: TLabel;
    txtArticulo: TLabel;
    txtCodigoBarras: TEdit;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure txtCodigoArticuloKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarProductoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtCodigoArticuloEnter(Sender: TObject);
    procedure txtPesoNetoEnter(Sender: TObject);
    procedure txtConceptoEnter(Sender: TObject);
    procedure txtCaldoEnter(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure txtPesoNetoExit(Sender: TObject);
    procedure txtConceptoExit(Sender: TObject);
    procedure txtCaldoExit(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtPlazoEnter(Sender: TObject);
    procedure txtPlazoExit(Sender: TObject);
    procedure txtFechaDisposicionEnter(Sender: TObject);
    procedure txtFechaDisposicionExit(Sender: TObject);
    procedure txtOperacionEnter(Sender: TObject);
    procedure txtOperacionExit(Sender: TObject);
    procedure txtPesoNetoKeyPress(Sender: TObject; var Key: Char);
    procedure txtTaraEnvaseExit(Sender: TObject);
    procedure txtTaraEnvaseEnter(Sender: TObject);
    procedure txtTipoEnvaseExit(Sender: TObject);
    procedure txtTipoEnvaseEnter(Sender: TObject);
    procedure txtNumeroEnvasesEnter(Sender: TObject);
    procedure txtNumeroEnvasesExit(Sender: TObject);
    procedure txtProductoEnter(Sender: TObject);
    procedure txtVariedadEnter(Sender: TObject);
    procedure txtCalibreEnter(Sender: TObject);
    procedure txtCategoriaEnter(Sender: TObject);
    procedure txtProductoExit(Sender: TObject);
    procedure txtVariedadExit(Sender: TObject);
    procedure txtCalibreExit(Sender: TObject);
    procedure txtCategoriaExit(Sender: TObject);
    procedure txtCodigoArticuloExit(Sender: TObject);
    procedure txtCantidadKeyPress(Sender: TObject; var Key: Char);
    function calcularImporte () : double;
    procedure txtCodigoBarrasChange(Sender: TObject);
    procedure obtenerDatosArticulo (codigo : integer; codigobarras : string);
    procedure txtCantidadExit(Sender: TObject);
    procedure txtPrecioExit(Sender: TObject);
    procedure txtCodigoBarrasEnter(Sender: TObject);
    procedure txtPrecioEnter(Sender: TObject);
    procedure txtCantidadEnter(Sender: TObject);
    procedure txtImporteEnter(Sender: TObject);
    procedure txtImporteExit(Sender: TObject);
    procedure txtCodigoBarrasExit(Sender: TObject);

  private
    { Private declarations }
    codigoArticuloAnterior : integer;
    cantidadActual : Double;
  public
    { Public declarations }
  end;

var
  formGFacturaLineaProveedor: TformGFacturaLineaProveedor;
const
  ventana = 'Lnea de Factura - Proveedor';
  ventanas = 'Lneas de Factura - Proveedor';

implementation

uses UnidadModuloDatos, UnidadMenuPrincipal, UnidadSeleccion,
  UnidadProcedimientos, UnidadGFactura, UnidadGFacturaProveedor;

{$R *.DFM}


procedure TformGFacturaLineaProveedor.obtenerDatosArticulo (codigo : integer; codigobarras : string);
begin
  md.TC2.Close;
  md.TC2.SQL.Clear;
  md.TC2.SQL.Add('Select a.*,t.nombre talla,c.nombre color,m.nombre marca,mo.nombre modelo,g.nombre genero,r.nombre rango, f.nombre familia');
  md.TC2.SQL.Add ('from ' + vtTablaArticulo +  ' a,' + vtTablaTalla +
      ' t,' + vtTablaColor + ' c,' + vtTablaMarca + ' m,' + vtTablaModelo + ' mo,' +
      vtTablaGenero + ' g,' + vtTablaRango + ' r,' + vtTablaFamilia + ' f');
  md.TC2.SQL.Add ('where t.codigo=a.codigotalla and c.codigo=a.codigocolor and m.codigo=a.codigomarca');
  md.TC2.SQL.Add ('and mo.codigo=a.codigomodelo and g.codigo=a.codigogenero and r.codigo=a.codigorango');
  md.TC2.SQL.Add('and f.codigo=a.codigofamilia');
  if codigobarras <> '' then
  begin
    md.TC2.SQL.Add('and a.codigobarras = :pCodigo');
    md.TC2.ParamByName('pCodigo').Value := codigobarras;
  end
  else
  begin
    md.TC2.SQL.Add('and a.codigo = :pCodigo');
    md.TC2.ParamByName('pCodigo').Value := codigo;
  end;

  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
  begin
    txtArticulo.Caption := md.TC2.fieldbyname('nombre').asString;
    if (md.tFacturaDetalleProveedorprecio.AsFloat = 0) or (codigoArticuloAnterior <> codigo) then
      md.tFacturaDetalleProveedorprecio.value := md.TC2.fieldbyname('precioventa').asFloat;
    if (md.tFacturaDetalleProveedorconcepto.AsString = '') or (codigoArticuloAnterior <> codigo) then
      md.tFacturaDetalleProveedorconcepto.value := md.TC2.fieldbyname('nombre').asString;
    if md.tFacturaDetalleProveedorcantidad.AsFloat = 0 then
      md.tFacturaDetalleProveedorcantidad.value := 1;
    md.tFacturaDetalleProveedorimporte.value := md.tc2.fieldbyname('precioventa').AsFloat;
    md.tFacturaDetalleProveedorporcentajedto.value := md.tc2.fieldbyname('porcentajedto').AsFloat;
    if codigobarras <> '' then
      md.tFacturaDetalleProveedorcodigoarticulo.value := md.tc2.fieldbyname('codigo').AsInteger;
    //txtCodigoBarras.Text := md.tc2.fieldbyname('codigobarras').AsString;
    ltalla.Caption := md.tc2.fieldbyname('talla').Value;
    lcolor.Caption := md.tc2.fieldbyname('color').Value;
    lmarca.Caption := md.tc2.fieldbyname('marca').Value;
    lmodelo.Caption := md.tc2.fieldbyname('modelo').Value;
    lrango.Caption := md.tc2.fieldbyname('rango').Value;
    lfamilia.Caption := md.tc2.fieldbyname('familia').Value;
    lstock.Caption := md.tc2.fieldbyname('stock').AsString;
    md.tFacturaDetalleProveedorimporte.Value := calcularImporte;
  end
  else
  begin
    txtArticulo.Caption := '';
    md.tFacturaDetalleProveedorprecio.value := 0;
    md.tFacturaDetalleProveedorconcepto.value := '';
    md.tFacturaDetalleProveedorcantidad.value := 1;
    md.tFacturaDetalleProveedorimporte.value := 0;
    ltalla.Caption := '';
    lcolor.Caption := '';
    lmarca.Caption := '';
    lmodelo.Caption := '';
    lrango.Caption := '';
    lfamilia.Caption := '';
    lstock.Caption := '';
  end;
  txtArticulo.Hint := txtArticulo.Caption;  
end;


function TformGFacturaLineaProveedor.calcularImporte () : double;
begin
  result := md.tFacturaDetalleProveedorprecio.AsFloat * md.tFacturaDetalleProveedorcantidad.AsFloat *
      (1 - md.tFacturaDetalleProveedorporcentajedto.AsFloat / 100);
end;

procedure TformGFacturaLineaProveedor.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformGFacturaLineaProveedor.BAceptarClick(Sender: TObject);
begin
  if (txtCodigoArticulo.Text = '') or (txtArticulo.Caption = '') then
  begin
    messagedlg ('Debe introducir un cdigo de artculo existente.', mtinformation, [mbok], 0);
    txtCodigoArticulo.setfocus;
    exit;
  end;

  try
    md.tFacturaDetalleProveedor.Post; //validar
    actualizarStock (true, md.tFacturaDetalleProveedorcantidad.AsFloat - cantidadActual, md.tFacturaDetalleProveedorcodigoarticulo.AsInteger);
  except
    txtCodigoArticulo.setfocus;
    raise;
  end;
  close;
end;

procedure TformGFacturaLineaProveedor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    if (md.tFacturaDetalleProveedor.State = dsedit) or
        (md.tFacturaDetalleProveedor.State = dsinsert) then
      md.tFacturaDetalleProveedor.cancel;
  except
    //silenciosa
  end;
  action := cafree;
end;

procedure TformGFacturaLineaProveedor.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGFacturaLineaProveedor.FormShow(Sender: TObject);
begin
  md.tFacturaDetalleProveedor.Open;

  if tag = 1 then //Nuevo
  begin
    caption := 'Nueva ' + ventana + '...';
    md.tFacturaDetalleProveedor.Open;
    md.tFacturaDetalleProveedor.Insert;
    md.tFacturaDetalleProveedor.FieldByName('CodigoFactura').Value := md.tFacturaProveedorcodigo.Value;
  end;

  if tag = 2 then //Modificar
  begin
    BSeleccionarProducto.Enabled := true;
    md.tFacturaDetalleProveedor.edit;
    txtCodigoArticulo.SetFocus;
    caption := 'Modificacin de ' + ventana + '...';
    obtenerDatosArticulo(md.tFacturaDetalleProveedorcodigoarticulo.Value, '');
    cantidadActual := md.tFacturaDetalleProveedorcantidad.AsFloat;    
  end;

  if tag = 3 then //zoom
  begin
    BAceptar.Visible := false;
    BSeleccionarProducto.Enabled := false;
    obtenerDatosArticulo(md.tFacturaDetalleProveedorcodigoarticulo.Value, '');
    caption := 'Visualizar de ' + ventana + '...';
  end;
end;

procedure TformGFacturaLineaProveedor.txtCodigoArticuloKeyPress(Sender: TObject;
  var Key: Char);
begin
  if formGFacturaProveedor.Tag <> 3 then //zoom
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarProductoClick(nil);
    end;
  end;
end;

procedure TformGFacturaLineaProveedor.BSeleccionarProductoClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumArticulo;
  formseleccion.ShowModal;
  if vtClaveElegida <> -1 then
  begin
    codigoArticuloAnterior := vtNumArticulo;
    md.tFacturaDetalleProveedorcodigoarticulo.Value := vtClaveElegida;
    obtenerDatosArticulo(vtClaveElegida, '');
  end;
end;

procedure TformGFacturaLineaProveedor.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //teclas de cursor para cambiar el foco
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (activecontrol is tdbmemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGFacturaLineaProveedor.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCodigoArticuloEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
  codigoArticuloAnterior := md.tFacturaDetalleProveedorcodigoarticulo.asInteger;
end;

procedure TformGFacturaLineaProveedor.txtPesoNetoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtConceptoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCaldoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtPesoNetoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtConceptoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtCaldoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtPlazoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtPlazoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtFechaDisposicionEnter(
  Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtFechaDisposicionExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtOperacionEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtOperacionExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtPesoNetoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFacturaLineaProveedor.txtTaraEnvaseExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;  
end;

procedure TformGFacturaLineaProveedor.txtTaraEnvaseEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtTipoEnvaseExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtTipoEnvaseEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtNumeroEnvasesEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtNumeroEnvasesExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtProductoEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtVariedadEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCalibreEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCategoriaEnter(Sender: TObject);
begin
  TDBComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtProductoExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtVariedadExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtCalibreExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtCategoriaExit(Sender: TObject);
begin
  TDBComboBox(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtCodigoArticuloExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  if not (md.tFacturaDetalleProveedorcodigoarticulo.Value = null) and
      not (md.tFacturaDetalleProveedorcodigoarticulo.Value = 0) then
    obtenerDatosArticulo (md.tFacturaDetalleProveedorcodigoarticulo.Value, '')
  else     
    txtArticulo.Caption := '';
  md.tFacturaDetalleProveedorimporte.Value := calcularImporte;
end;

procedure TformGFacturaLineaProveedor.txtCantidadKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGFacturaLineaProveedor.txtCodigoBarrasChange(Sender: TObject);
begin
  if (Length (txtCodigoBarras.Text) = 13) or (Length (txtCodigoBarras.Text) = 8) then
    obtenerDatosArticulo (0, txtCodigoBarras.Text);
end;

procedure TformGFacturaLineaProveedor.txtCantidadExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  md.tFacturaDetalleProveedorimporte.Value := calcularImporte;
end;

procedure TformGFacturaLineaProveedor.txtPrecioExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  md.tFacturaDetalleProveedorimporte.Value := calcularImporte;
end;

procedure TformGFacturaLineaProveedor.txtCodigoBarrasEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtPrecioEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtCantidadEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtImporteEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGFacturaLineaProveedor.txtImporteExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGFacturaLineaProveedor.txtCodigoBarrasExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

end.
