unit UnidadGModelo;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows, dxExEdtr, dxCntner, dxTL, dxDBCtrl, dxDBGrid,
  dxDBTLCl, dxGrClms, ZDataset, dxEditor, dxEdLib, dxDBELib;

type
  TformGModelo = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    txtObservacion: TDBMemo;
    txtNombre: TDBEdit;
    txtCodigo: TDBEdit;
    lCodigo: TLabel;
    Label13: TLabel;
    Label1: TLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure txtNombreEnter(Sender: TObject);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtObservacionEnter(Sender: TObject);
    procedure txtObservacionExit(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGModelo: TformGModelo;
const
  ventana = 'Modelo';
  ventanas = 'Modelos';

implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion;

var
  tTabla : TZTable;
  valorAnterior : string; //para modificacin de Nombre
{$R *.DFM}

procedure TformGModelo.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGModelo.BAceptarClick(Sender: TObject);
begin
  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      MessageDlg ('El campo Cdigo debe tener un valor.', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      exit;
    end;
  end;
  if txtNombre.Text = '' then
  begin
    MessageDlg ('El campo Nombre debe tener un valor.', mtWarning, [mbok], 0);
    TxtNombre.setfocus;
    exit;
  end;
  //si es una modificacin y se modifica el nombre, comprobar duplicidad
  {if vtAccion = 'modificar' then
  begin
    if vtDuplicadoNombreTercero then
    begin
      if AnsiUpperCase(txtNombre.Text) <> AnsiUpperCase(valorAnterior) then //s se ha modificado
      begin
        if comprobarDuplicado(txtNombre.Text, vtTablaTercero) then
        begin
          tabGeneral.Show;
          MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
          txtNombre.SelectAll;
          txtnombre.SetFocus;
          exit;
        end;
      end;
    end;
  end;
  //si es nuevo comprobar duplicidad
  if vtAccion = 'nuevo' then
  begin
    if not vtDuplicadoNombreTercero then
    begin
      if comprobarDuplicado(txtNombre.Text, vtTablaTercero) then
      begin
        tabGeneral.Show;
        MessageDlg('El ' + ventana + ' [' + txtNombre.Text + '] ya existe.', mtWarning, [mbok], 0);
        txtNombre.SelectAll;
        txtnombre.SetFocus;
        exit;
      end;
    end;
  end; }

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    try
      ttabla.Post; //validar
    except
      txtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TformGModelo.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformGModelo.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGModelo.FormShow(Sender: TObject);
begin
  tTabla := md.tModelo;
  ttabla.Active := true;
  txtNombre.SetFocus;
  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';
    lCodigo.Visible := false;
    txtCodigo.Visible := false;
    tTabla.Insert;
  end;

  if vtAccion = 'modificar' then
  begin
    ttabla.locate ('Codigo', vtCodigo, []);
    caption := 'Modificacin de ' + ventana + '...';
    valorAnterior := ttabla.fieldbyname('Nombre').Value;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtNombre.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformGModelo.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformGModelo.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGModelo.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGModelo.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGModelo.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGModelo.txtObservacionEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;


procedure TformGModelo.txtObservacionExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
end;



procedure TformGModelo.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

end.
