unit UnidadGVale;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls,
  variants, windows, dxExEdtr, dxCntner, dxTL, dxDBCtrl, dxDBGrid,
  dxDBTLCl, dxGrClms, ZDataset, dxEditor, dxEdLib, dxDBELib, QRCtrls,
  QuickRpt;

type
  TformGVale = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    txtNombre: TDBEdit;
    txtCodigo: TDBEdit;
    label22: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    dxDBDateEdit1: TdxDBDateEdit;
    Label4: TLabel;
    DBEdit2: TDBEdit;
    Label5: TLabel;
    DBEdit3: TDBEdit;
    bImprimir: TBitBtn;
    lImpresion: TQuickRep;
    QRBand8: TQRBand;
    lNombre: TQRLabel;
    lDNI: TQRLabel;
    lDireccion: TQRLabel;
    lImporte: TQRLabel;
    lFechaDevolucion: TQRLabel;
    lCodigo: TQRLabel;
    lNombreEmpresa: TQRLabel;
    QRLabel1: TQRLabel;
    dxDBDateEdit2: TdxDBDateEdit;
    Label6: TLabel;
    lFechaCaducidad: TQRLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure txtNombreEnter(Sender: TObject);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtDNIEnter(Sender: TObject);
    procedure txtCapitalEnter(Sender: TObject);
    procedure txtObservacionEnter(Sender: TObject);
    procedure txtContactoEnter(Sender: TObject);
    procedure txtTelefonoEnter(Sender: TObject);
    procedure txtTelefono2Enter(Sender: TObject);
    procedure txtFax2Enter(Sender: TObject);
    procedure txtTelefono3Enter(Sender: TObject);
    procedure txtFaxEnter(Sender: TObject);
    procedure txtWebEnter(Sender: TObject);
    procedure txtEMailEnter(Sender: TObject);
    procedure txtDireccionEnter(Sender: TObject);
    procedure txtCPEnter(Sender: TObject);
    procedure txtPoblacionEnter(Sender: TObject);
    procedure txtProvinciaEnter(Sender: TObject);
    procedure txtPaisEnter(Sender: TObject);
    procedure txtEntidadEnter(Sender: TObject);
    procedure txtOficinaEnter(Sender: TObject);
    procedure txtDCEnter(Sender: TObject);
    procedure txtIBANEnter(Sender: TObject);
    procedure txtDNIExit(Sender: TObject);
    procedure txtCapitalExit(Sender: TObject);
    procedure txtObservacionExit(Sender: TObject);
    procedure txtContactoExit(Sender: TObject);
    procedure txtTelefono2Exit(Sender: TObject);
    procedure txtTelefonoExit(Sender: TObject);
    procedure txtTelefono3Exit(Sender: TObject);
    procedure txtFaxExit(Sender: TObject);
    procedure txtWebExit(Sender: TObject);
    procedure txtFax2Exit(Sender: TObject);
    procedure txtEMailExit(Sender: TObject);
    procedure txtDireccionExit(Sender: TObject);
    procedure txtEntidadExit(Sender: TObject);
    procedure txtOficinaExit(Sender: TObject);
    procedure txtDCExit(Sender: TObject);
    procedure txtIBANExit(Sender: TObject);
    procedure txtPorcentajeBeneficioEnter(Sender: TObject);
    procedure txtPorcentajeBeneficioExit(Sender: TObject);
    procedure txtPorcentajeBeneficioKeyPress(Sender: TObject;
      var Key: Char);
    procedure txtCapitalKeyPress(Sender: TObject; var Key: Char);
    procedure txtPorcentajeIVAEnter(Sender: TObject);
    procedure txtPorcentajeIVAExit(Sender: TObject);
    procedure txtPorcentajeIVAKeyPress(Sender: TObject; var Key: Char);
    procedure txtCPExit(Sender: TObject);
    procedure txtPoblacionExit(Sender: TObject);
    procedure txtProvinciaExit(Sender: TObject);
    procedure txtPaisExit(Sender: TObject);
    procedure txtTipoEnter(Sender: TObject);
    procedure txtTipoExit(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure bImprimirClick(Sender: TObject);
    function ValidarRegistro () : boolean;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGVale: TformGVale;
const
  ventana = 'Vale';
  ventanas = 'Vales';

implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion;

var
  tTabla : TZTable;
  valorAnterior : string; //para modificacin de Nombre
{$R *.DFM}


function TformGVale.ValidarRegistro () : boolean;
begin
  result := false;
  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      MessageDlg ('El campo Cdigo debe tener un valor.', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      result := false;
    end;
  end;

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    try
      ttabla.Post; //validar
      result := true;
    except
      txtNombre.setfocus;
      raise;
    end;
  end;
end;

procedure TformGVale.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;


procedure TformGVale.BAceptarClick(Sender: TObject);
begin
  if ValidarRegistro then
    close;
end;

procedure TformGVale.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformGVale.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGVale.FormShow(Sender: TObject);
begin
  tTabla := md.tVale;
  ttabla.Active := true;
  txtNombre.SetFocus;
  if vtAccion = 'nuevo' then
  begin
    caption := 'Aadir ' + ventana + '...';
    lCodigo.Visible := false;
    txtCodigo.Visible := false;
    tTabla.Insert;
    tTabla.FieldByName('fechadevolucion').AsDateTime := Date;
  end;

  if vtAccion = 'modificar' then
  begin
    ttabla.locate ('Codigo', vtCodigo, []);
    caption := 'Modificacin de ' + ventana + '...';
    valorAnterior := ttabla.fieldbyname('Nombre').Value;
    tTabla.Edit;
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    txtNombre.Enabled := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TformGVale.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformGVale.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGVale.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtDNIEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtCapitalEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtObservacionEnter(Sender: TObject);
begin
  TDBMemo(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtContactoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtTelefonoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtTelefono2Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtFax2Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtTelefono3Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtFaxEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtWebEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtEMailEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtDireccionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtCPEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtPoblacionEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtProvinciaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtPaisEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtEntidadEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtOficinaEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtDCEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtIBANEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtDNIExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtCapitalExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtObservacionExit(Sender: TObject);
begin
  TDBMemo(sender).Color := clWindow;
end;

procedure TformGVale.txtContactoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtTelefono2Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtTelefonoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtTelefono3Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtFaxExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtWebExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtFax2Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtEMailExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtDireccionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtEntidadExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtOficinaExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtDCExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtIBANExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtPorcentajeBeneficioEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtPorcentajeBeneficioExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtPorcentajeBeneficioKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGVale.txtCapitalKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGVale.txtPorcentajeIVAEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtPorcentajeIVAExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtPorcentajeIVAKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGVale.txtCPExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtPoblacionExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtProvinciaExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtPaisExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.txtTipoEnter(Sender: TObject);
begin
  TComboBox(sender).Color := clMoneyGreen;
end;

procedure TformGVale.txtTipoExit(Sender: TObject);
begin
  TComboBox(sender).Color := clWindow;
end;

procedure TformGVale.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGVale.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TformGVale.bImprimirClick(Sender: TObject);
begin
  if ValidarRegistro then
  begin
    lCodigo.Caption := tTabla.fieldbyname('codigo').AsString;
    lNombre.Caption := 'Nombre: ' + tTabla.fieldbyname('nombre').AsString;
    lDNI.Caption := 'DNI: ' + tTabla.fieldbyname('dni').AsString;
    lDireccion.Caption := 'Direccin: ' + tTabla.fieldbyname('direccion').AsString;
    lImporte.Caption := 'Importe: ' + tTabla.fieldbyname('importe').AsString;
    lFechaDevolucion.Caption := 'Fecha Dev.: ' + tTabla.fieldbyname('fechadevolucion').AsString;
    lFechaCaducidad.Caption := 'Fecha Caducidad: ' + tTabla.fieldbyname('fechacaducidad').AsString;
    lNombreEmpresa.Caption := vtEmpresaNombre;
    lImpresion.Preview;
  end;
end;

end.
