unit UnidadGenero;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, variants, dxTL, dxDBCtrl,
  dxDBGrid, dxCntner, dxExEdtr, dxDBTLCl, dxGrClms, QuickRpt, QRCtrls, dxgridmenus, ZDataset;

type
  TformGenero = class(TForm)
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    Tabla: TdxDBGrid;
    actOP: TActionList;
    actEnviarExcel: TAction;
    actMostrarOcultarAutofiltros: TAction;
    actEnviarTodosTexto: TAction;
    actMostrarOcultarSumario: TAction;
    actMostrarOcultarPanelAgrupacion: TAction;
    actEnviarTodosXML: TAction;
    actEnviarHTML: TAction;
    actEnviarPortaPapeles: TAction;
    pmEnvio: TPopupMenu;
    EnviartodosaExcel1: TMenuItem;
    EnviartodosaTexto1: TMenuItem;
    EnviartodosaHTML1: TMenuItem;
    EnviartodosaXML1: TMenuItem;
    N4: TMenuItem;
    Copiaralportapapeles1: TMenuItem;
    dlGuardar: TSaveDialog;
    ActionList1: TActionList;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActVisualizar: TAction;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    actImprimirDatosSobre: TAction;
    LImpresionSobre: TQuickRep;
    TitleBand1: TQRBand;
    LNombre: TQRLabel;
    LDireccion: TQRLabel;
    LCP: TQRLabel;
    LPais: TQRLabel;
    Tablacodigo: TdxDBGridColumn;
    Tablanombre: TdxDBGridMaskColumn;
    Tablaobservacion: TdxDBGridMaskColumn;
    Tablacodigoman: TdxDBGridMaskColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActVisualizarExecute(Sender: TObject);
    procedure actEnviarExcelExecute(Sender: TObject);
    procedure actEnviarHTMLExecute(Sender: TObject);
    procedure actEnviarPortaPapelesExecute(Sender: TObject);
    procedure actEnviarTodosTextoExecute(Sender: TObject);
    procedure actEnviarTodosXMLExecute(Sender: TObject);
    procedure actMostrarOcultarAutofiltrosExecute(Sender: TObject);
    procedure actMostrarOcultarPanelAgrupacionExecute(Sender: TObject);
    procedure actMostrarOcultarSumarioExecute(Sender: TObject);
    procedure TablaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure llenarGrid(Posicion: Integer);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formGenero: TformGenero;
const
  ventana = 'Gnero';
  ventanas = 'Gneros';

implementation

uses UnidadMenuPrincipal, UnidadModuloDatos,
 UnidadProcedimientos, UnidadGGenero, UnidadImprimir;
{$R *.DFM}

var
  tTabla : TZTable; //tabla del mdulo de datos que
                    //se utilizar para hacer la conexin con la ventana
                    //de modificacin/insercin/visualizacin

procedure TformGenero.llenarGrid(Posicion: Integer);
begin
  md.tcGenero.Close;
  md.tcGenero.SQL.Clear;
  md.tcGenero.SQL.Add('SELECT * FROM ' + vtTablaGenero);
  md.tcGenero.Open;
  md.tcGenero.RecNo := Posicion;
end;


procedure TformGenero.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
   esNumINI ('Posicin final', ventana, md.tcgenero.RecNo);
   md.tcgenero.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformGenero.FormShow(Sender: TObject);
begin
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
  screen.cursor := crdefault;
end;

procedure TformGenero.ActNuevoExecute(Sender: TObject);
begin
  vtAccion := 'nuevo';
  application.createform(tformGgenero, formGgenero);
  formGgenero.ShowModal;
  LlenarGrid(md.tcgenero.RecNo);
end;

procedure TformGenero.ActEliminarExecute(Sender: TObject);
var
  nombre : string;
  eliminar : boolean;
begin
  if md.tcgenero.RecordCount <= 0 then
    MessageDlg ('No hay datos para eliminar.', mtWarning, [mbok], 0)
  else
  begin
    tTabla.Active := true;
    if tTabla.locate('Codigo', md.tcgeneroCodigo.value, []) then
    begin
      if not varisnull(md.tcgeneroNombre.Value) then
        nombre := md.tcgeneroNombre.Value
      else
        nombre := null;
      eliminar := true;
      with md.TC do
      begin
        //comprobamos integridad referencial: Artculos
        Close;
        SQL.Clear;
        SQL.Add('SELECT count(CodigoGenero) NumeroT');
        SQL.Add('FROM ' + vtTablaArticulo);
        SQL.Add('WHERE Codigogenero = :pCodigo');
        ParamByName('pCodigo').DataType := ftString;
        ParamByName('pCodigo').Value := md.tcGenerocodigo.Value;
        Open;
        if FieldByName('NumeroT').value > 0 then
        begin
          eliminar := false;
          messagedlg ('El ' + ventana + ' [' + nombre + '] no se puede ' +
              'eliminar ya que existe en artculos.', mtWarning, [mbok], 0);
        end;

        if eliminar then
        begin
          if messagedlg ('Est seguro que desea eliminar el ' + ventana + ': ' +
              nombre + '?', mtConfirmation, [mbyes, mbno], 0) = mryes then
          begin
            try
              ttabla.Delete;
              ActRefrescarExecute(nil);
            except
              raise;
            end;
          end;
        end;
      end;
    end;
  end;
end;


procedure TformGenero.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformGenero.ActModificarExecute(Sender: TObject);
begin
  if md.tcGenero.RecordCount <= 0 then
    messagedlg ('No hay datos para modificar.', mtInformation, [mbok], 0)
  else
  begin
    if not varisnull(md.tcGeneroCodigo.value) then
    begin
      vtAccion := 'modificar';
      vtCodigo := md.tcGenerocodigo.Value;
      application.createform(TformGGenero, formGGenero);
      formGGenero.ShowModal;
      LlenarGrid(md.tcGenero.RecNo);
    end
    else
      messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.', mtError, [mbok], 0);
  end;
end;

procedure TformGenero.TablaDblClick(Sender: TObject);
begin
  if ActModificar.Enabled = true then
    ActModificarExecute(nil);
end;

procedure TformGenero.ActRefrescarExecute(Sender: TObject);
begin
  LlenarGrid(md.tcGenero.RecNo);
end;

procedure TformGenero.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformGenero.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformGenero.ActImprimirExecute(Sender: TObject);
begin
  if md.tcGenero.RecordCount <= 0 then
    messagedlg ('No hay datos para imprimir.', mtInformation, [mbok], 0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := vtNumGenero;
    formImprimir.showmodal;
  end;
end;

procedure TformGenero.ActVisualizarExecute(Sender: TObject);
begin
  if md.tcGenero.RecordCount <= 0 then
    messagedlg ('No hay datos para mostrar.', mtInformation, [mbok], 0)
  else
  begin
    vtAccion := 'zoom';
    vtCodigo := md.tcGeneroCodigo.value;
    application.createform(TformGGenero, formGGenero);
    formGGenero.ShowModal;
  end;
end;

procedure TformGenero.actEnviarExcelExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros Excel (*.xls)|*.xls|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a Excel';
  dlGuardar.DefaultExt := 'xls';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXLS(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformGenero.actEnviarHTMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros HTML (*.html)|*.html|Ficheros HTML (*.htm)|*.htm|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a HTML';
  dlGuardar.DefaultExt := 'html';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToHTML(dlguardar.filename, true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;


procedure TformGenero.actEnviarPortaPapelesExecute(Sender: TObject);
begin
  tabla.CopyAllToClipboard;
  MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
end;

procedure TformGenero.actEnviarTodosTextoExecute(Sender: TObject);
var
  separador : string;
begin
  dlguardar.Filter := 'Ficheros de texto (*.txt)|*.txt|Ficheros Word (*.doc)|*.doc|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a texto sin formato';
  dlguardar.FileName := ventanas;
  dlGuardar.DefaultExt := 'txt';
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    separador := InputBox('Separador para campos...', 'Introduzca un carcter que ser el separador de campos:', '#');
    if Length(separador) > 1 then
      MessageDlg('Slo debe seleccionar un carcter. Se anular el proceso.', mtWarning, [mbok], 0)
    else
    begin
      tabla.SaveToText(dlguardar.filename, true, #9, separador, separador);
      MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
    end;  
  end;    
end;

procedure TformGenero.actEnviarTodosXMLExecute(Sender: TObject);
begin
  dlguardar.Filter := 'Ficheros XML (*.xml)|*.xml|Todos los ficheros|*.*';
  dlguardar.Title := 'Exportar ' + ventanas + ' a XML';
  dlGuardar.DefaultExt := 'xml';
  dlguardar.FileName := ventanas;
  if not DirectoryExists(extractfilepath(application.ExeName) + 'Exportados') then
    createdir (extractfilepath(application.ExeName) + 'Exportados');
  dlguardar.InitialDir := extractfilepath(application.ExeName) + 'Exportados';
  if dlGuardar.execute then
  begin
    tabla.SaveToXML(dlguardar.FileName,true);
    MessageDlg('Los datos han sido exportados correctamente.', mtInformation, [mbok], 0);
  end;
end;

procedure TformGenero.actMostrarOcultarAutofiltrosExecute(
  Sender: TObject);
begin
  tabla.Filter.Active := not tabla.Filter.Active;
  actMostrarOcultarAutofiltros.Checked := tabla.Filter.Active;
end;

procedure TformGenero.actMostrarOcultarPanelAgrupacionExecute(
  Sender: TObject);
begin
  tabla.ShowGroupPanel := not tabla.ShowGroupPanel;
  actMostrarOcultarPanelAgrupacion.Checked := tabla.ShowGroupPanel;
end;

procedure TformGenero.actMostrarOcultarSumarioExecute(Sender: TObject);
begin
  tabla.ShowSummaryFooter := not tabla.ShowSummaryFooter;
  actMostrarOcultarSumario.Checked := tabla.ShowSummaryFooter;
end;

procedure TformGenero.TablaMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button <> mbRight) or (Shift <> []) then
    Exit;
  TdxDBGridPopupMenuManager.Instance.ShowGridPopupMenu(Sender as TdxDBGrid);
end;

procedure TformGenero.FormCreate(Sender: TObject);
begin
  tTabla := md.tGenero;
  LlenarGrid(leNumINI ('Posicin final', ventana, 0));
end;

end.
