CREATE DATABASE IF NOT EXISTS ropa;
USE ropa;

--
-- Definition of table `articulo`
--

DROP TABLE IF EXISTS `articulo`;
CREATE TABLE `articulo` (
  `codigo` int(11) NOT NULL auto_increment,
  `codigotalla` int(11) default NULL,
  `codigocolor` int(11) default NULL,
  `codigomarca` int(11) default NULL,
  `codigomodelo` int(11) default NULL,
  `preciocompra` double default NULL,
  `precioventa` double default NULL,
  `observacion` varchar(255) default NULL,
  `codigogenero` int(11) default NULL,
  `stockminimo` double default NULL,
  `stock` double default NULL,
  `codigobarras` varchar(30) default NULL,
  `codigoman` varchar(20) default NULL,
  `codigorango` int(11) default NULL,
  `nombre` varchar(150) NOT NULL default '',
  `descripcion` varchar(255) default NULL,
  `codigofamilia` int(11) default NULL,
  `fechaalta` datetime default NULL,
  `porcentajedto` double default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `cobro`
--

DROP TABLE IF EXISTS `cobro`;
CREATE TABLE `cobro` (
  `codigo` int(11) NOT NULL auto_increment,
  `fecha` datetime default NULL,
  `importe` double default NULL,
  `codigocliente` int(11) default NULL,
  `descripcion` varchar(255) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `color`
--

DROP TABLE IF EXISTS `color`;
CREATE TABLE `color` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `contador`
--

DROP TABLE IF EXISTS `contador`;
CREATE TABLE `contador` (
  `tabla` varchar(100) NOT NULL default '',
  `contador` int(11) default NULL,
  PRIMARY KEY  (`tabla`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `factura`
--

DROP TABLE IF EXISTS `factura`;
CREATE TABLE `factura` (
  `codigo` int(11) NOT NULL auto_increment,
  `numero` varchar(10) NOT NULL default '',
  `importetotal` double default NULL,
  `baseimponible` double default NULL,
  `porcentajeiva` double default NULL,
  `importeiva` double default NULL,
  `porcentajedescuento` double default NULL,
  `importedescuento` double default NULL,
  `codigocliente` int(11) NOT NULL default '0',
  `fecha` datetime default '0000-00-00 00:00:00',
  `cobrado` char(1) default NULL,
  `observacion` varchar(255) default NULL,
  `importecobrado` double default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `facturadetalle`
--

DROP TABLE IF EXISTS `facturadetalle`;
CREATE TABLE `facturadetalle` (
  `codigo` int(11) NOT NULL auto_increment,
  `codigofactura` int(11) default NULL,
  `codigoarticulo` int(11) default NULL,
  `concepto` varchar(150) default NULL,
  `cantidad` double default NULL,
  `importe` double default '0',
  `precio` double default NULL,
  `porcentajedto` double default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `facturaproveedor`
--

DROP TABLE IF EXISTS `facturaproveedor`;
CREATE TABLE `facturaproveedor` (
  `codigo` int(11) NOT NULL auto_increment,
  `numero` varchar(10) NOT NULL default '',
  `importetotal` double default NULL,
  `baseimponible` double default NULL,
  `porcentajeiva` double default NULL,
  `importeiva` double default NULL,
  `porcentajedescuento` double default NULL,
  `importedescuento` double default NULL,
  `codigoproveedor` int(11) NOT NULL default '0',
  `fecha` datetime default '0000-00-00 00:00:00',
  `cobrado` char(1) default NULL,
  `observacion` varchar(255) default NULL,
  `importecobrado` double default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `facturaproveedordetalle`
--

DROP TABLE IF EXISTS `facturaproveedordetalle`;
CREATE TABLE `facturaproveedordetalle` (
  `codigo` int(11) NOT NULL auto_increment,
  `codigofactura` int(11) default NULL,
  `codigoarticulo` int(11) default NULL,
  `concepto` varchar(150) default NULL,
  `cantidad` double default NULL,
  `importe` double default NULL,
  `precio` double default NULL,
  `porcentajedto` double default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `familia`
--

DROP TABLE IF EXISTS `familia`;
CREATE TABLE `familia` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `formapago`
--

DROP TABLE IF EXISTS `formapago`;
CREATE TABLE `formapago` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `gasto`
--

DROP TABLE IF EXISTS `gasto`;
CREATE TABLE `gasto` (
  `codigo` int(11) NOT NULL auto_increment,
  `codigoproveedor` int(11) NOT NULL default '0',
  `fecha` datetime default NULL,
  `importe` double default NULL,
  `observacion` varchar(255) default NULL,
  `pagado` char(1) default NULL,
  `fechapago` datetime default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `genero`
--

DROP TABLE IF EXISTS `genero`;
CREATE TABLE `genero` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `marca`
--

DROP TABLE IF EXISTS `marca`;
CREATE TABLE `marca` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `modelo`
--

DROP TABLE IF EXISTS `modelo`;
CREATE TABLE `modelo` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `pago`
--

DROP TABLE IF EXISTS `pago`;
CREATE TABLE `pago` (
  `codigo` int(11) NOT NULL auto_increment,
  `fecha` datetime default NULL,
  `importe` double default NULL,
  `codigoproveedor` int(11) default NULL,
  `descripcion` varchar(255) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `rango`
--

DROP TABLE IF EXISTS `rango`;
CREATE TABLE `rango` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `sql`
--

DROP TABLE IF EXISTS `sql`;
CREATE TABLE `sql` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `sql` text,
  `fecha` datetime default NULL,
  `administrador` tinyint(1) default NULL,
  `actualizacion` tinyint(1) default NULL,
  `nombre` varchar(100) default NULL,
  `descripcion` varchar(255) default NULL,
  `modificacion` char(1) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Dumping data for table `sql`
--

/*!40000 ALTER TABLE `sql` DISABLE KEYS */;
INSERT INTO `sql` (`codigo`,`sql`,`fecha`,`administrador`,`actualizacion`,`nombre`,`descripcion`,`modificacion`) VALUES 
 (1,'select * from articulo','2006-05-24 19:22:56',NULL,NULL,'Artículos','Artículos',NULL),
 (2,'select * from talla','2006-05-24 19:24:05',NULL,NULL,'Tallas','Tallas',NULL),
 (3,'select t.Nombre Proveedor, sum(p.importe) Importe\r\nfrom pago p, tercero t\r\nwhere p.codigoproveedor = t.codigo\r\ngroup by codigoproveedor','2006-05-24 21:04:43',NULL,NULL,'Importe pagado por Proveedor','Importe pagado por Proveedor','N'),
 (4,'select t.Nombre Cliente, sum(c.importe) Importe\r\nfrom cobro c, tercero t\r\nwhere c.codigocliente = t.codigo\r\ngroup by codigocliente','2006-05-24 21:08:00',NULL,NULL,'Importe cobrado por Cliente','Importe cobrado por Cliente','N');
/*!40000 ALTER TABLE `sql` ENABLE KEYS */;


--
-- Definition of table `talla`
--

DROP TABLE IF EXISTS `talla`;
CREATE TABLE `talla` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `tercero`
--

DROP TABLE IF EXISTS `tercero`;
CREATE TABLE `tercero` (
  `codigo` int(11) NOT NULL auto_increment,
  `nombre` varchar(100) NOT NULL default '',
  `cif` varchar(15) default NULL,
  `fechaalta` datetime default '0000-00-00 00:00:00',
  `direccion` varchar(100) default NULL,
  `telefono` varchar(50) default NULL,
  `poblacion` varchar(100) default NULL,
  `provincia` varchar(50) default NULL,
  `cp` int(11) default '0',
  `personacontacto` varchar(100) default NULL,
  `web` varchar(200) default NULL,
  `email` varchar(200) default NULL,
  `fax` varchar(50) default NULL,
  `pais` varchar(45) default NULL,
  `tipo` varchar(10) default NULL,
  `observacion` varchar(255) default NULL,
  `codigoman` varchar(20) default NULL,
  `ccc` varchar(20) default NULL,
  `riegomaximo` float default NULL,
  `puntos` int(10) unsigned default NULL,
  `deudaalcanzada` float default NULL,
  `codigoformapago` int(10) unsigned default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Definition of table `vale`
--

DROP TABLE IF EXISTS `vale`;
CREATE TABLE `vale` (
  `codigo` int(10) unsigned NOT NULL auto_increment,
  `fechadevolucion` datetime default NULL,
  `importe` float default NULL,
  `nombre` varchar(150) default NULL,
  `dni` varchar(15) default NULL,
  `direccion` varchar(150) default NULL,
  `fechacaducidad` datetime default NULL,
  PRIMARY KEY  (`codigo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;